/*
 * Copyright 2007 Kickmogu Co. Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */



/*
 * 쐬: 2006/11/15
 *
 */
package com.kickmogu.rhythm.core;

import com.kickmogu.*;
import com.kickmogu.rhythm.core.SessionManager;
import com.kickmogu.rhythm.core.dao.AttachFileDao;
import com.kickmogu.s2.S2Util;

import java.io.*;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Category;

public class AttachFileDownloader extends HttpServlet {
	static Category log = Category.getInstance(AttachFileDownloader.class.getName());

	protected void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException {
		
		try {
			/*
			 * TODO _E[hł邩ǂ𔻒肷郍WbNKv
			 */
			int attachId = Integer.parseInt(req.getParameter("attachId"));
			String sessionId = req.getParameter("sessionId");
			int memId = Integer.parseInt(req.getParameter("memId"));
			// ZbV̗LmF
			if (!SessionManager.isValidSession(sessionId, memId)) {
				log.info("Upload File session timeout:" + memId + "," + sessionId);
				return;
			}

			AttachFileDao attachFileDao = (AttachFileDao) S2Util.getS2Container().getComponent(AttachFileDao.class);
			AttachFile attachFile = attachFileDao.getAttachFile(attachId);
			res.setContentType("application/kikmogu-stream");
			res.setHeader("Content-Disposition", "inline; filename=\""
					+ new String(attachFile.getFilename().getBytes("Shift_JIS"), "8859_1") + "\"");
			log.debug("download file:" + attachFile.getFilename() + "," + sessionId + "," + attachId);
			File path = new File(Config.getProperty("attachfile.rootdir"), "" + attachFile.getId());
			path = new File(path, "" + attachFile.getId());
			BufferedInputStream in = new BufferedInputStream(new FileInputStream(path));
			try {
				OutputStream out = res.getOutputStream();
				byte[] buf = new byte[512];
				int read_sz;
				while ((read_sz = in.read(buf)) > 0)
					out.write(buf, 0, read_sz);
				out.close();
			} finally {
				in.close();
			}
		} catch (Exception e) {
			log.error(e);
		}

	}
}
