/*
 * Copyright 2007 Kickmogu Co. Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */



package com.kickmogu.rhythm.core.dao;

import java.util.List;

import com.kickmogu.rhythm.core.AttachFile;

/**
 * @author mogu
 */
public interface AttachFileDao {
    public Class BEAN = AttachFile.class;
    public static final String getAttachFile_QUERY = "id = ?";
    public static final String listAttachFile_QUERY = "sourceId = ? and sourceTable = ? order by id";
    
    public int update(AttachFile attachFile);
    
    public int insert(AttachFile attachFile);

    public int delete(AttachFile attachFile);
    public AttachFile getAttachFile(int id);
    public List<AttachFile> listAttachFile(int sourceId, String sourceTable);
}
