/*
 * 쐬: 2008/02/25
 *
 */
package com.kickmogu.rhythm.mail;

import java.util.*;

import javax.mail.FetchProfile;
import javax.mail.Flags;
import javax.mail.Folder;
import javax.mail.Message;

import org.apache.log4j.Category;

import com.kickmogu.rhythm.core.Member;
import com.kickmogu.rhythm.mail.ws.MailWs;

public class MailQueue extends Thread {
	static Category log = Category.getInstance(MailQueue.class.getName());

	private static Random rnd = new Random();
	private String queueId;
	private Date requestDate;
	private List<Mail> queue;
	private boolean finish;
	private Member member;
	private int mailSettingId;
	private String folderName;

	public MailQueue(Member member, int mailSettingId, String folderName) {
		setRequestDate(new Date());
		setQueue(new ArrayList<Mail>());
		setFinish(false);
		this.member = member;
		this.mailSettingId = mailSettingId;
		this.folderName = folderName;
		String key = member.getId() + "_" + mailSettingId + "_" + folderName + "_" + System.currentTimeMillis() + "_" + rnd.nextLong();
		setQueueId(key);
	}
	
	public boolean equals(Object o) {
		if (o instanceof MailQueue) {
			MailQueue q = (MailQueue) o;
			return getQueueId().equals(q.getQueueId());
		}
		return false;
	}

	/**
	 * @return queue ߂܂B
	 */
	public List<Mail> getQueue() {
		return queue;
	}

	/**
	 * @param queue queue ݒB
	 */
	public void setQueue(List<Mail> queue) {
		this.queue = queue;
	}

	/**
	 * @return requestDate ߂܂B
	 */
	public Date getRequestDate() {
		return requestDate;
	}

	/**
	 * @param requestDate requestDate ݒB
	 */
	public void setRequestDate(Date requestDate) {
		this.requestDate = requestDate;
	}

	/**
	 * @return finish ߂܂B
	 */
	public boolean isFinish() {
		return finish;
	}

	/**
	 * @param finish finish ݒB
	 */
	public void setFinish(boolean finish) {
		this.finish = finish;
	}

	public void doQueue() throws Exception {
		MailWs mailWs = new MailWs();
    	Folder target = mailWs.getTargetFolder(member, mailSettingId, folderName);
    	setFinish(false);
		target.open(Folder.READ_ONLY);
		try {
			Message[] msgs = target.getMessages();
			FetchProfile fp = new FetchProfile();
			fp.add(FetchProfile.Item.ENVELOPE);
			fp.add(FetchProfile.Item.FLAGS);
			target.fetch(msgs, fp);
			  
			for (int i = msgs.length - 1; i >= 0 ; i--) {
				 if (!msgs[i].getFlags().contains(Flags.Flag.DELETED)) {
					 try {
					     Mail mail = mailWs.getMessage2Mail(i, msgs[i], false);
					     getQueue().add(mail);
					 } catch (Exception ex) {
						 log.error("listMails:" + mailSettingId + "," + folderName + "," + i, ex);
					 }
				 }
			}
		} finally {
	    	setFinish(true);
			target.close(false);
		}
	}
	
	public void run() {
		try {
			doQueue();
		} catch (Exception e) {
			log.error(e);
		}
	}

	/**
	 * @return folderName ߂܂B
	 */
	public String getFolderName() {
		return folderName;
	}

	/**
	 * @param folderName folderName ݒB
	 */
	public void setFolderName(String folderName) {
		this.folderName = folderName;
	}

	/**
	 * @return mailSettingId ߂܂B
	 */
	public int getMailSettingId() {
		return mailSettingId;
	}

	/**
	 * @param mailSettingId mailSettingId ݒB
	 */
	public void setMailSettingId(int mailSettingId) {
		this.mailSettingId = mailSettingId;
	}

	/**
	 * @return member ߂܂B
	 */
	public Member getMember() {
		return member;
	}

	/**
	 * @param member member ݒB
	 */
	public void setMember(Member member) {
		this.member = member;
	}

	/**
	 * @return queueId ߂܂B
	 */
	public String getQueueId() {
		return queueId;
	}

	/**
	 * @param queueId queueId ݒB
	 */
	public void setQueueId(String queueId) {
		this.queueId = queueId;
	}
}
