/*
 * Copyright 2007 Kickmogu Co. Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */



/*
 * 쐬: 2007/01/15
 *
 */
package com.kickmogu.rhythm.mail.ws;

import java.io.IOException;
import java.util.Map;

import org.apache.log4j.Category;

import com.kickmogu.rhythm.core.BaseResult;
import com.kickmogu.rhythm.core.HttpCmdAction;
import com.kickmogu.rhythm.mail.*;

public class FastGetMailQueue implements HttpCmdAction {
	private static int RESULT_SIZE = 100;
	static Category log = Category.getInstance(FastGetMailQueue.class.getName());

	public String listMails(String queueId) throws IOException {
    	MailQueue queue = MailQueueManager.getQueue(queueId);
		StringBuffer out = new StringBuffer();
		while (queue.getQueue().size() <= RESULT_SIZE && !queue.isFinish()) {
			try {
				// L[܂܂ő҂
				Thread.sleep(100);
			} catch (InterruptedException e) {
			}
		}
		int loopCnt = queue.isFinish() && queue.getQueue().size() < RESULT_SIZE ? queue.getQueue().size() : RESULT_SIZE;
		for (int i = 0; i < loopCnt; i++) {
			Mail mail = queue.getQueue().remove(0);
			 try {
			     out.append(mail.getIdx() + "\t" + mail.getMsgId() + "\t" 
			    		 + (mail.getSubject() != null ? mail.getSubject().replace("\r", "").replace("\n", "") : "") + "\t" 
			    		 + (mail.getFromaddr() != null && mail.getFromaddr().length > 0 && mail.getFromaddr()[0] != null ? mail.getFromaddr()[0].replace("\r", "").replace("\n", "") : "") 
			    		 + "\t" + (mail.getSendDate() != null ? mail.getSendDate().getTime() : 0) + "\n");
			 } catch (Exception ex) {
				 log.error("listMails:" + queueId + "," + mail.getIdx(), ex);
			 }
		}
		return out.toString();
	}
    
	public BaseResult doAction(Map<String, String[]> params) throws Exception {
		BaseResult result = new BaseResult();
		result.setResult(listMails(params.get("queueId")[0]));
		if (((String) result.getResult()).length() == 0) {
			result.setStatusCode(100);
		}
		return result;
	}

}
